INCLUDE=/home/james/jwasm/include
export INCLUDE
AR = ar rcs
JW = jwasm -elf -zcw 
OBJECTS =atodw.o \
catstrng.o \
chrstr.o \
clearfltvar.o \
clearintvar.o \
clearLngstrng_bffr.o \
clearstrng_bffr.o \
clearstrvar.o \
clear_allvars.o \
closeafile.o \
closeallfiles.o \
copystrng.o \
copystrng_bffr.o \
datestr.o \
dblArryElement.o \
dimstrarray.o \
Do_initialize.o \
dwtoa.o \
freeArray.o \
getArryOffst.o \
getfilehandle.o \
getfilelength.o \
get_sys_date.o \
get_sys_time.o \
leftstr.o \
lsetstr.o \
ltoa.o \
mid_str.o \
mkdstr.o \
mkistr.o \
mkqstr.o \
movstrng_bffr.o \
quadArryElement.o \
readfltstr.o \
readintstr.o \
readQintstr.o \
redimarray.o \
rightstr.o \
rsetstr.o \
setupiobuffer.o \
spacestr.o \
stringstr.o \
strsFval.o \
strsIval.o \
szLeft.o \
szMid.o \
szRight.o \
timestr.o \
FloatToStr2.o \
StrToFloat.o \
value2strng.o



all : library
	@echo
	@echo Succesful Build

ltoa.o : ltoa.c
	gcc -c ltoa.c -oltoa.o

FloatToStr2.o : FloatToStr2.c
	gcc -c FloatToStr2.c -oFloatToStr2.o

StrToFloat.o : StrToFloat.c
	gcc -c StrToFloat.c -oStrToFloat.o

value2strng.o : value2strng.c
	gcc -c value2strng.c -ovalue2strng.o

%.o : %.asm
	$(JW) $<

library : $(OBJECTS)
	@$(AR) libbxblib.a $(OBJECTS)


clean_object_files:
	@echo Cleaning Up
	@rm *.o

clean : clean_object_files
	@echo Removing All Object and Library Files
	@rm *.a

