/* BXBLIB.C */
/*
/*  *************BxbAsm Compiler*************
/*  Copyright: sarbayo (c) 2004-2012
/* ========================================================================= */


#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>


#include "bxblib.h"





void _stdcall ClearScreen()
{
    COORD coordScreen = { 0, 0 };    // home for the cursor
    DWORD cCharsWritten;
    CONSOLE_SCREEN_BUFFER_INFO csbi;
    DWORD dwConSize;

    HANDLE hConsole;


    hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

    // Get the number of character cells in the current buffer.

    if(!GetConsoleScreenBufferInfo(hConsole, &csbi))
    {
        printf("abort at: 1\n");
        return;
    }

    dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

    // Fill the entire screen with blanks.

    if(!FillConsoleOutputCharacter(hConsole, (TCHAR) ' ', dwConSize, coordScreen, &cCharsWritten))
    {
        printf("abort at: 2\n");
        return;
    }

    // Get the current text attribute.

    if(!GetConsoleScreenBufferInfo(hConsole, &csbi))
    {
        printf("abort at: 3\n");
        return;
    }

    // Set the buffer's attributes accordingly.

    if(!FillConsoleOutputAttribute(hConsole, csbi.wAttributes, dwConSize, coordScreen, &cCharsWritten))
    {
        printf("abort at: 4\n");
        return;
    }

    // Put the cursor at its home coordinates.

    SetConsoleCursorPosition(hConsole, coordScreen);

}
/*------ end ClearScreen ------*/



