;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  99
	VARX2I		DD  33
	VARX3S		DB  'test',0
	VARX4S		DB  'testing',0
	VARX5S		DB  'testing',0
	VARX6S		DB  'if:expression = true',0
	VARX7I		DD  100
	VARX8S		DB  'hello',0
	VARX9S		DB  'elseif:expression = true',0
	VARX10S		DB  'else:expressions = false',0
	VARX11S		DB  'done',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	abcs		DD	?
	xyzs		DD	?
	_int_start	dd	?
	abc		DD	?
	xyz		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
  cls
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP abc		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX2I			; load integer
  FISTP xyz		; store integer, pop stack
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX3S			; load temp variable address
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX4S			; load temp variable address
  call copystrng
  mov  edi, [xyzs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  xyzs, eax			; store address-pointer
  ;--------------------<if>
  mov  esi, [xyzs]			; address of source string
  mov  edi, offset VARX5S		; load temp variable address
  invoke StrLen, addr VARX5S		; get string length
  .if eax == 0
    inc  eax
  .endif
  mov  ecx, eax				; Load length of string
  cld			; clear direction flag: work upward
  repe cmpsb		; Compare and repeat
  jne  Unq_2_Label
  FILD abc
  FILD xyz
  FXCH ST(1) 			; flip registers
  FCOMPP 
  FSTSW AX
  SAHF
  jnae Unq_2_Label
  ;--------------------<block>
    printstr VARX6S
    printstr lf
  ;--------------------<end-block>
  jmp  Unq_1_Label
  ;--------------------<elseif>
Unq_2_Label:
  FILD abc
  FILD VARX7I
  FXCH ST(1) 			; flip registers
  FCOMPP 
  FSTSW AX
  SAHF
  jbe  Unq_5_Label
  mov  esi, [abcs]			; address of source string
  mov  edi, offset VARX8S		; load temp variable address
  invoke StrLen, addr VARX8S		; get string length
  .if eax == 0
    inc  eax
  .endif
  mov  ecx, eax				; Load length of string
  cld			; clear direction flag: work upward
  repe cmpsb		; Compare and repeat
  jnbe Unq_4_Label
  ;--------------------<block>
Unq_5_Label:
    printstr VARX9S
    printstr lf
  ;--------------------<end-block>
  jmp  Unq_1_Label
  ;--------------------<else>
Unq_4_Label:
  ;--------------------<block>
    printstr VARX10S
    printstr lf
  ;--------------------<end-block>
  ;--------------------<endif>
Unq_1_Label:
  printstr VARX11S
  printstr lf
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
