;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  0
	VARX2S		DB  NULL
	VARX3S		DB  NULL
	VARX4I		DD  42
	VARX5S		DB  'abcs$ = ',0
	VARX6S		DB  'testing',0
	VARX7I		DD  4
	VARX8I		DD  5
	VARX9I		DD  3
	VARX10I		DD  3
	VARX11I		DD  3
	VARX12S		DB  '>',0
	VARX13S		DB  '<',0
	VARX14I		DD  199
	VARX15I		DD  10
	VARX16S		DB  '>',0
	VARX17S		DB  '<',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	abcs		DD	?
	xyzs		DD	?
	_int_start	dd	?
	xyzi		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP xyzi		; store integer, pop stack
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX2S			; load temp variable address
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX3S			; load temp variable address
  call copystrng
  mov  edi, [xyzs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  xyzs, eax			; store address-pointer
  cls
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX4I			; load integer
  FISTP xyzi		; store integer, pop stack
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  eax, xyzi			; load the ascii value
  call chrstr
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
  printstr VARX5S
  mov  eax, [abcs]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX6S			; load temp variable address
  call copystrng
  mov  edi, [xyzs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  xyzs, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, [xyzs]			; address of source string
  mov  eax, VARX7I			; load the count
  call leftstr
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
  mov  eax, [abcs]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, [xyzs]			; address of source string
  mov  eax, VARX8I			; load the count
  call rightstr
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
  mov  eax, [abcs]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, [xyzs]			; address of source string
  mov  ebx, VARX9I			; load the start
  dec  ebx
  mov  eax, VARX10I			; load the count
  call mid_str
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
  mov  eax, [abcs]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  eax, VARX11I			; load the count
  call spacestr
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
  printstr VARX12S
  mov  eax, [abcs]
  .if eax != 0
    printvar eax
  .endif
  printstr VARX13S
  printstr lf
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  eax, VARX14I			; load the value
  mov  integer, eax
  call strsIval
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
  mov  eax, [abcs]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  eax, VARX15I			; load the count
  mov  ebx, xyzi			; load value
  call stringstr
  call copystrng
  mov  edi, [abcs]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abcs, eax			; store address-pointer
  printstr VARX16S
  mov  eax, [abcs]
  .if eax != 0
    printvar eax
  .endif
  printstr VARX17S
  printstr lf
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
