;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1S		DB  NULL
	VARX2S		DB  NULL
	VARX3S		DB  NULL
	VARX4S		DB  NULL
	VARX5I		DD  0
	VARX6I		DD  0
	VARX7I		DD  0
	VARX8I		DD  0
	VARX9S		DB  'Press any key to begin: ',0
	VARX10S		DB  NULL
	VARX11S		DB  'Enter your name:',0
	VARX12S		DB  'First: ',0
	VARX13S		DB  ' Initial: ',0
	VARX14S		DB  ' Last: ',0
	VARX15S		DB  'Enter your age and birth date:',0
	VARX16S		DB  'Age: ',0
	VARX17S		DB  ' Month: ',0
	VARX18S		DB  '/Day: ',0
	VARX19S		DB  '/Year: ',0
	VARX20S		DB  'Press any key: ',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	abc		DD	?
	first		DD	?
	init		DD	?
	last		DD	?
	_int_start	dd	?
	age		DD	?
	mo		DD	?
	day		DD	?
	year		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX1S			; load temp variable address
  call copystrng
  mov  edi, [abc]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abc, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX2S			; load temp variable address
  call copystrng
  mov  edi, [first]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  first, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX3S			; load temp variable address
  call copystrng
  mov  edi, [init]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  init, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX4S			; load temp variable address
  call copystrng
  mov  edi, [last]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  last, eax			; store address-pointer
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX5I			; load integer
  FISTP age		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX6I			; load integer
  FISTP mo		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX7I			; load integer
  FISTP day		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX8I			; load integer
  FISTP year		; store integer, pop stack
  cls
  printstr VARX9S
Start:
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  call inkeystr
  call copystrng
  mov  edi, [abc]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abc, eax			; store address-pointer
  ;--------------------<if>
  mov  esi, [abc]			; address of source string
  mov  edi, offset VARX10S		; load temp variable address
  invoke StrLen, addr VARX10S		; get string length
  .if eax == 0
    inc  eax
  .endif
  mov  ecx, eax				; Load length of string
  cld			; clear direction flag: work upward
  repe cmpsb		; Compare and repeat
  jne  Unq_1_Label
  ;--------------------<block>
  jmp  Start
  ;--------------------<end-block>
  ;--------------------<endif>
Unq_1_Label:
  printstr lf
  printstr VARX11S
  printstr lf
  printstr VARX12S
  call wherexy
  lea  eax, StringBffr
  mov  [eax], byte ptr 0
  mov  eax, BUFSIZE
  call inputstr		; console input
  call copystrng
  mov  edi, [first]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  first, eax			; store address-pointer
  call reset_cursor
  printstr VARX13S
  call wherexy
  lea  eax, StringBffr
  mov  [eax], byte ptr 0
  mov  eax, BUFSIZE
  call inputstr		; console input
  call copystrng
  mov  edi, [init]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  init, eax			; store address-pointer
  call reset_cursor
  printstr VARX14S
  call wherexy
  lea  eax, StringBffr
  mov  [eax], byte ptr 0
  mov  eax, BUFSIZE
  call inputstr		; console input
  call copystrng
  mov  edi, [last]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  last, eax			; store address-pointer
  call reset_cursor
  printstr lf
  printstr VARX15S
  printstr lf
  printstr VARX16S
  call wherexy
  mov  eax, BUFFR_SIZ
  call inputstr		; console input
  invoke StrToFloat, esi, addr qLVAR
  FLD   qLVAR
  FISTP age
  call reset_cursor
  printstr VARX17S
  call wherexy
  mov  eax, BUFFR_SIZ
  call inputstr		; console input
  invoke StrToFloat, esi, addr qLVAR
  FLD   qLVAR
  FISTP mo
  call reset_cursor
  printstr VARX18S
  call wherexy
  mov  eax, BUFFR_SIZ
  call inputstr		; console input
  invoke StrToFloat, esi, addr qLVAR
  FLD   qLVAR
  FISTP day
  call reset_cursor
  printstr VARX19S
  call wherexy
  mov  eax, BUFFR_SIZ
  call inputstr		; console input
  invoke StrToFloat, esi, addr qLVAR
  FLD   qLVAR
  FISTP year
  call reset_cursor
  printstr lf
  mov  eax, [first]
  .if eax != 0
    printvar eax
  .endif
  printstr tab
  mov  eax, [init]
  .if eax != 0
    printvar eax
  .endif
  printstr tab
  mov  eax, [last]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  age			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr tab
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  mo			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr tab
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  day			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr tab
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  year			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX20S
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
