;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1S		DB  NULL
	VARX2S		DB  '1: ',0
	VARX3S		DB  '2:enter a string: ',0
	VARX4S		DB  '3:enter a string: ',0
	VARX5S		DB  '4:enter a string: ',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	abc		DD	?
	_int_start	dd	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX1S			; load temp variable address
  call copystrng
  mov  edi, [abc]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abc, eax			; store address-pointer
  cls
  printstr VARX2S
  lea  eax, StringBffr
  mov  [eax], byte ptr 0
  mov  eax, BUFSIZE
  call inputstr		; console input
  printstr lf		; add a line feed after Line Input
  call copystrng
  mov  edi, [abc]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abc, eax			; store address-pointer
  printstr lf
  mov  eax, [abc]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
  printstr VARX3S
  lea  eax, StringBffr
  mov  [eax], byte ptr 0
  mov  eax, BUFSIZE
  call inputstr		; console input
  printstr lf		; add a line feed after Line Input
  call copystrng
  mov  edi, [abc]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abc, eax			; store address-pointer
  printstr lf
  mov  eax, [abc]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
  printstr VARX4S
  call wherexy
  lea  eax, StringBffr
  mov  [eax], byte ptr 0
  mov  eax, BUFSIZE
  call inputstr		; console input
  call copystrng
  mov  edi, [abc]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abc, eax			; store address-pointer
  call reset_cursor
  printstr lf
  mov  eax, [abc]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
  printstr VARX5S
  call wherexy
  lea  eax, StringBffr
  mov  [eax], byte ptr 0
  mov  eax, BUFSIZE
  call inputstr		; console input
  call copystrng
  mov  edi, [abc]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  abc, eax			; store address-pointer
  call reset_cursor
  printstr tab		; add a tab after Line Input
  printstr lf
  mov  eax, [abc]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
