;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  0
	VARX2I		DD  0
	VARX3I		DD  0
	VARX4I		DD  99
	VARX5F		DQ  1.75
	VARX6S		DB  'A',0
	VARX7I		DD  3
	VARX8F		DQ  5.8
	VARX9F		DQ  0.0174533
	VARX10I		DD  11
	VARX11I		DD  10
	VARX12F		DQ  3.1
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	_int_start	dd	?
	ixyz		DD	?
	iabc		DD	?
	_flt_start	dd	?
	labc		DQ	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP ixyz		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX2I			; load integer
  FISTP iabc		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX3I			; load integer
  FSTP  labc		; store float, pop stack
  cls
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX4I			; load integer
  FISTP ixyz		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  ixyz			; load integer
  FLD   VARX5F			; load float
  FSUBP ST(1), ST		; subtract and pop
  FISTP  iLVAR
  invoke abs, iLVAR
  mov   iLVAR, eax
  FILD  iLVAR
  FISTP iabc		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  iabc			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  esi, offset VARX6S			; load temp variable address
  xor  eax, eax
  mov  al,  [esi]
  mov  iLVAR, eax
  FILD  iLVAR
  FISTP iabc		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  iabc			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  ixyz			; load integer
  FILD  VARX7I			; load integer
  FDIVP ST(1), ST			; divide and pop
  FSTP  qLVAR
  invoke atan, qLVAR
  FSTP  labc		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   labc			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX8F			; load float
  FLD   VARX9F			; load float
  FMULP ST(1), ST			; multiply and pop
  FSTP  qLVAR
  invoke cos, qLVAR
  FSTP  labc		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   labc			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  ixyz			; load integer
  FILD  VARX10I			; load integer
  FDIVP ST(1), ST			; divide and pop
  FSTP  qLVAR
  invoke sin, qLVAR
  FSTP  labc		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   labc			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  ixyz			; load integer
  FILD  VARX11I			; load integer
  FDIVP ST(1), ST			; divide and pop
  FSTP  qLVAR
  invoke tan, qLVAR
  FSTP  labc		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   labc			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  ixyz			; load integer
  FSTP  qLVAR
  invoke sqrt, qLVAR
  FSTP  labc		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   labc			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  ixyz			; load integer
  FLD   VARX12F			; load float
  FDIVP ST(1), ST			; divide and pop
  invoke FpuTrunc, 0, 0, SRC1_FPU or DEST_FPU
  FISTP iabc		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  iabc			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
