;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  10
	VARX2I		DD  99
	VARX3F		DQ  1.75
	VARX4S		DB  'A',0
	VARX5I		DD  3
	VARX6F		DQ  5.8
	VARX7F		DQ  0.0174533
	VARX8I		DD  11
	VARX9I		DD  10
	VARX10F		DQ  3.1
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	_int_start	dd	?
	abc		DD	?
	xyz		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP abc		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX2I			; load integer
  FISTP xyz		; store integer, pop stack
  cls
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyz			; load integer
  FLD   VARX3F			; load float
  FSUBP ST(1), ST		; subtract and pop
  FISTP  iLVAR
  invoke abs, iLVAR
  mov   iLVAR, eax
  FILD  iLVAR
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  esi, offset VARX4S			; load temp variable address
  xor  eax, eax
  mov  al,  [esi]
  mov  iLVAR, eax
  FILD  iLVAR
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyz			; load integer
  FILD  VARX5I			; load integer
  FDIVP ST(1), ST			; divide and pop
  FSTP  qLVAR
  invoke atan, qLVAR
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX6F			; load float
  FLD   VARX7F			; load float
  FMULP ST(1), ST			; multiply and pop
  FSTP  qLVAR
  invoke cos, qLVAR
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyz			; load integer
  FILD  VARX8I			; load integer
  FDIVP ST(1), ST			; divide and pop
  FSTP  qLVAR
  invoke sin, qLVAR
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyz			; load integer
  FILD  VARX9I			; load integer
  FDIVP ST(1), ST			; divide and pop
  FSTP  qLVAR
  invoke tan, qLVAR
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyz			; load integer
  FSTP  qLVAR
  invoke sqrt, qLVAR
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyz			; load integer
  FLD   VARX10F			; load float
  FDIVP ST(1), ST			; divide and pop
  invoke FpuTrunc, 0, 0, SRC1_FPU or DEST_FPU
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
