;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  0
	VARX2I		DD  0
	VARX3I		DD  1
	VARX4I		DD  5
	VARX5S		DB  '*',0
	VARX6I		DD  1
	VARX7I		DD  28
	VARX8S		DB  ' ',0
	VARX9I		DD  1
	VARX10S		DB  '*',0
	VARX11I		DD  1
	VARX12I		DD  1
	VARX13I		DD  30
	VARX14S		DB  '*',0
	VARX15I		DD  1
	VARX16S		DB  NULL
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	_int_start	dd	?
	x		DD	?
	y		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP x		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX2I			; load integer
  FISTP y		; store integer, pop stack
  cls
  call Top
  call Center
  call Bottom
  jmp  TheEnd
Center:
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX3I			; load integer
  FISTP x		; store integer, pop stack
  ;--------------------<while>
Unq_2_Label:
  FILD x
  FILD VARX4I
  FXCH ST(1) 			; flip registers
  FCOMPP 
  FSTSW AX
  SAHF
  jnbe Unq_1_Label
  ;--------------------<block>
    printstr VARX5S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX6I			; load integer
  FISTP y		; store integer, pop stack
    ;--------------------<while>
Unq_4_Label:
    FILD y
    FILD VARX7I
    FXCH ST(1) 			; flip registers
    FCOMPP 
    FSTSW AX
    SAHF
    jnbe Unq_3_Label
    ;--------------------<block>
      printstr VARX8S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  y			; load integer
  FILD  VARX9I			; load integer
  FADDP ST(1), ST			; add to ST(0) and pop
  FISTP y		; store integer, pop stack
    ;--------------------<end-block>
    jmp  Unq_4_Label
    ;--------------------<wend>
Unq_3_Label:
    printstr VARX10S
    printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  x			; load integer
  FILD  VARX11I			; load integer
  FADDP ST(1), ST			; add to ST(0) and pop
  FISTP x		; store integer, pop stack
  ;--------------------<end-block>
  jmp  Unq_2_Label
  ;--------------------<wend>
Unq_1_Label:
  ret
; --------------------------------------------------
Top:
Bottom:
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX12I			; load integer
  FISTP x		; store integer, pop stack
  ;--------------------<while>
Unq_6_Label:
  FILD x
  FILD VARX13I
  FXCH ST(1) 			; flip registers
  FCOMPP 
  FSTSW AX
  SAHF
  jnbe Unq_5_Label
  ;--------------------<block>
    printstr VARX14S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  x			; load integer
  FILD  VARX15I			; load integer
  FADDP ST(1), ST			; add to ST(0) and pop
  FISTP x		; store integer, pop stack
  ;--------------------<end-block>
  jmp  Unq_6_Label
  ;--------------------<wend>
Unq_5_Label:
  printstr VARX16S
  printstr lf
  ret
; --------------------------------------------------
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
