;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  11100
	VARX2I		DD  32000
	VARX3L		DD  33000
	VARX4L		DD  99000
	VARX5F		DQ  33000.33
	VARX6F		DQ  99000.47
	VARX7F		DQ  333000.33
	VARX8F		DQ  999000.47
	VARX9S		DB  'abc=',0
	VARX10S		DB  'xyz=',0
	VARX11S		DB  'abcl%=',0
	VARX12S		DB  'xyzl%=',0
	VARX13S		DB  'abcf!=',0
	VARX14S		DB  'xyzf!=',0
	VARX15S		DB  'abcd#=',0
	VARX16S		DB  'xyzd#=',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	_int_start	dd	?
	abc		DD	?
	xyz		DD	?
	abcl		DD	?
	xyzl		DD	?
	_flt_start	dd	?
	abcf		DQ	?
	xyzf		DQ	?
	abcd		DQ	?
	xyzd		DQ	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
Start1:
  cls
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP abc		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX2I			; load integer
  FISTP xyz		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX3L			; load integer
  FISTP abcl		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX4L			; load integer
  FISTP xyzl		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX5F			; load float
  FSTP  abcf		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX6F			; load float
  FSTP  xyzf		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX7F			; load float
  FSTP  abcd		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX8F			; load float
  FSTP  xyzd		; store float, pop stack
  printstr lf
  printstr VARX9S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  abc			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX10S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyz			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX11S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  abcl			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX12S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xyzl			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX13S
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   abcf			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX14S
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   xyzf			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX15S
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   abcd			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr VARX16S
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   xyzd			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
TheEnd:
; --------------------------------------------------
  call clear_allvars
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
