;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  0
	VARX2I		DD  10
	VARX3I		DD  3
	VARX4I		DD  0
	VARX5I		DD  10
	VARX6I		DD  2
	VARX7S		DB  'power=',0
	VARX8S		DB  'imod=',0
	VARX9I		DD  30
	VARX10I		DD  9
	VARX11S		DB  'imod=',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	_int_start	dd	?
	power		DD	?
	tten		DD	?
	three		DD	?
	imod		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP power		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX2I			; load integer
  FISTP tten		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX3I			; load integer
  FISTP three		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX4I			; load integer
  FISTP imod		; store integer, pop stack
  call Start1
  jmp  DONE
Start1:
  cls
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX5I			; load integer
  FSTP  qLVAR
  FILD  VARX6I			; load integer
  FSTP  qRVAR
  invoke pow, qLVAR, qRVAR
  FISTP power		; store integer, pop stack
  printstr VARX7S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  power			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  tten			; load integer
  FSTP  qLVAR
  FILD  three			; load integer
  FSTP  qRVAR
  invoke fmod, qLVAR, qRVAR
  FISTP imod		; store integer, pop stack
  printstr VARX8S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  imod			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX9I			; load integer
  FSTP  qLVAR
  FILD  VARX10I			; load integer
  FSTP  qRVAR
  invoke fmod, qLVAR, qRVAR
  FISTP imod		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  tten			; load integer
  FSTP  qLVAR
  FILD  imod			; load integer
  FSTP  qRVAR
  invoke fmod, qLVAR, qRVAR
  FISTP imod		; store integer, pop stack
  printstr VARX11S
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  imod			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  ret
; --------------------------------------------------
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
