;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1S		DB  NULL
	VARX2S		DB  NULL
	VARX3I		DD  0
	VARX4I		DD  0
	VARX5I		DD  0
	VARX6I		DD  0
	VARX7S		DB  'Opening Test File',0
	VARX8S		DB  'r',0
	VARX9S		DB  'test.txt',0
	VARX10S		DB  NULL
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	input		DD	?
	next		DD	?
	_int_start	dd	?
	valuea		DD	?
	valueb		DD	?
	_flt_start	dd	?
	valuec		DQ	?
	valued		DQ	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX1S			; load temp variable address
  call copystrng
  mov  edi, [input]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  input, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX2S			; load temp variable address
  call copystrng
  mov  edi, [next]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  next, eax			; store address-pointer
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX3I			; load integer
  FISTP valuea		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX4I			; load integer
  FISTP valueb		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX5I			; load integer
  FSTP  valuec		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX6I			; load integer
  FSTP  valued		; store float, pop stack
  cls
  printstr VARX7S
  printstr lf
; --------------------------------------------------
  invoke fopen, addr VARX9S, addr VARX8S	; OPEN file
  mov  edi, offset iohandles
  mov  [edi], eax
  mov  edi, offset iobuffers
  mov  eax, 256
  call setupiobuffer
Start:
  ;--------------------<if>
  mov  eax, 0
  call getfilehandle
  invoke feof, eax
  cmp  eax, 0
  jz   Unq_1_Label
  ;--------------------<block>
  jmp  Finish
  ;--------------------<end-block>
  ;--------------------<endif>
Unq_1_Label:
; --------------------------------------------------
  mov  edi, offset iobuffers
  mov  esi, [edi]
  mov  integer, esi
  mov  eax, 0
  call getfilehandle
  mov  esi, integer
  invoke fgets, esi, BUFSIZE, eax
  mov  esi, integer
  mov  edi, [input]
  call movstrng_bffr
  mov  input, eax
  mov  edi, [next]
  call movstrng_bffr
  mov  next, eax
  mov  edi, offset valuea
  call readintstr
  mov  edi, offset valueb
  call readintstr
  mov  edi, offset valuec
  call readfltstr
  mov  edi, offset valued
  call readfltstr
  ;--------------------<if>
  mov  esi, [input]			; address of source string
  mov  edi, offset VARX10S		; load temp variable address
  invoke StrLen, addr VARX10S		; get string length
  .if eax == 0
    inc  eax
  .endif
  mov  ecx, eax				; Load length of string
  cld			; clear direction flag: work upward
  repe cmpsb		; Compare and repeat
  jne  Unq_2_Label
  ;--------------------<block>
  jmp  Start
  ;--------------------<end-block>
  ;--------------------<endif>
Unq_2_Label:
  mov  eax, [input]
  .if eax != 0
    printvar eax
  .endif
  printstr tab
  mov  eax, [next]
  .if eax != 0
    printvar eax
  .endif
  printstr tab
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  valuea			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr tab
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  valueb			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr tab
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   valuec			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr tab
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   valued			; load float
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  jmp  Start
Finish:
; --------------------------------------------------
  mov  eax, 0
  call closeafile
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
