;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1S		DB  NULL
	VARX2S		DB  'Opening Test File',0
	VARX3S		DB  'r',0
	VARX4S		DB  'test.txt',0
	VARX5S		DB  NULL
	VARX6S		DB  NULL
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	input		DD	?
	_int_start	dd	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX1S			; load temp variable address
  call copystrng
  mov  edi, [input]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  input, eax			; store address-pointer
  cls
  printstr VARX2S
  printstr lf
; --------------------------------------------------
  invoke fopen, addr VARX4S, addr VARX3S	; OPEN file
  mov  edi, offset iohandles
  mov  [edi], eax
  mov  edi, offset iobuffers
  mov  eax, 256
  call setupiobuffer
Start:
  ;--------------------<if>
  mov  eax, 0
  call getfilehandle
  invoke feof, eax
  cmp  eax, 0
  jz   Unq_1_Label
  ;--------------------<block>
  jmp  Finish
  ;--------------------<end-block>
  ;--------------------<endif>
Unq_1_Label:
; --------------------------------------------------
  mov  esi, offset input
  mov  edi, [input]
  call clearLngstrng_bffr
  mov  eax, 0
  call getfilehandle
  invoke fgets, input, BUFSIZE, eax
  ;--------------------<if>
  mov  esi, [input]			; address of source string
  mov  edi, offset VARX5S		; load temp variable address
  invoke StrLen, addr VARX5S		; get string length
  .if eax == 0
    inc  eax
  .endif
  mov  ecx, eax				; Load length of string
  cld			; clear direction flag: work upward
  repe cmpsb		; Compare and repeat
  jne  Unq_2_Label
  ;--------------------<block>
  jmp  Start
  ;--------------------<end-block>
  ;--------------------<endif>
Unq_2_Label:
  mov  eax, [input]
  .if eax != 0
    printvar eax
  .endif
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX6S			; load temp variable address
  call copystrng
  mov  edi, [input]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  input, eax			; store address-pointer
  jmp  Start
Finish:
; --------------------------------------------------
  mov  eax, 0
  call closeafile
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
