;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1F		DQ  1.012345
	VARX2F		DQ  123.456
	VARX3I		DD  1
	VARX4S		DB  NULL
	VARX5S		DB  NULL
	VARX6S		DB  'rb+',0
	VARX7S		DB  'test.txt',0
	VARX8I		DD  1
	VARX9S		DB  'ALL DONE',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	C1		DD	?
	D		DD	?
	_int_start	dd	?
	rec		DD	?
	_flt_start	dd	?
	az		DQ	?
	bz		DQ	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX1F			; load float
  FSTP  az		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FLD   VARX2F			; load float
  FSTP  bz		; store float, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX3I			; load integer
  FISTP rec		; store integer, pop stack
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX4S			; load temp variable address
  call copystrng
  mov  edi, [C1]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  C1, eax			; store address-pointer
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX5S			; load temp variable address
  call copystrng
  mov  edi, [D]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  D, eax			; store address-pointer
  cls
; --------------------------------------------------
  invoke fopen, addr VARX7S, addr VARX6S	; OPEN file
  .if eax == NULL
    invoke fopen, addr VARX7S, addr _Altern_$
  .endif
  mov  edi, offset iohandles
  mov  [edi], eax
  mov  edi, offset iobuffers
  mov  eax, 16
  call setupiobuffer
; --------------------------------------------------
  mov  edi, offset iobuffers		; FIELD #, data...
  mov  eax, [edi]
  mov  C1, eax			; create string pointer
  add  eax, 8
  mov  D, eax			; create string pointer
  add  eax, 8
; --------------------------------------------------
  mov  edi, [C1]
  mov  esi, offset bz
  call mkdstr
  mov  edi, [D]
  mov  esi, offset az
  call mkdstr
; --------------------------------------------------
  mov  eax, rec
  dec  eax
  mov  ebx, eax
  mov  eax, 16
  mul  bx
  push eax			; save this record number
  mov  eax, 0
  call getfilehandle
  pop  ebx
  invoke fseek, eax, ebx, SEEK_SET
; --------------------------------------------------
  mov  edi, offset iobuffers
  mov  esi, [edi]
  push esi
  add  esi, 16
  mov  eax, 0
  mov  [esi], al
  mov  eax, 0
  call getfilehandle
  pop esi
  invoke fwrite, esi, 16, 1, eax
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  rec			; load integer
  FILD  VARX8I			; load integer
  FADDP ST(1), ST			; add to ST(0) and pop
  FISTP rec		; store integer, pop stack
; --------------------------------------------------
  mov  eax, 0
  call closeafile
; --------------------------------------------------
  call clear_allvars
  printstr VARX9S
  printstr lf
TheEnd:
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
