;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  0
	VARX2I		DD  99
	VARX3I		DD  10
	VARX4I		DD  20
	VARX5I		DD  30
	VARX6I		DD  40
	VARX7I		DD  50
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	_int_start	dd	?
	xvalue		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
	MyArray		DD	?
			DW	61	dup(?)
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  mov  esi, offset MyArray			; dimension an array
  mov  edi, esi
  add  edi, 4
  mov word ptr [edi], 1
  add  edi, 2
  mov word ptr [edi], 1
  call dimstrarray
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP xvalue		; store integer, pop stack
  cls
; --------------------------------------------------
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  FINIT 			; initialize x87
  FILD  VARX2I			; load integer
  pop  edi
  call dblArryElement
  FISTP dword ptr [eax]		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
  printstr lf
; --------------------------------------------------
  mov  esi, offset MyArray			; re-dimension an array
  mov  edi, esi
  add  edi, 4
  mov word ptr [edi], 1
  add  edi, 2
  mov word ptr [edi], 5
  call redimarray
; --------------------------------------------------
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  FINIT 			; initialize x87
  FILD  VARX3I			; load integer
  pop  edi
  call dblArryElement
  FISTP dword ptr [eax]		; store integer, pop stack
; --------------------------------------------------
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 2
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  FINIT 			; initialize x87
  FILD  VARX4I			; load integer
  pop  edi
  call dblArryElement
  FISTP dword ptr [eax]		; store integer, pop stack
; --------------------------------------------------
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 3
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  FINIT 			; initialize x87
  FILD  VARX5I			; load integer
  pop  edi
  call dblArryElement
  FISTP dword ptr [eax]		; store integer, pop stack
; --------------------------------------------------
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 4
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  FINIT 			; initialize x87
  FILD  VARX6I			; load integer
  pop  edi
  call dblArryElement
  FISTP dword ptr [eax]		; store integer, pop stack
; --------------------------------------------------
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 5
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  FINIT 			; initialize x87
  FILD  VARX7I			; load integer
  pop  edi
  call dblArryElement
  FISTP dword ptr [eax]		; store integer, pop stack
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 2
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 3
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 4
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 5
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  mov  edi, offset MyArray
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 2
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  FILD dword ptr [eax]			; load integer
  FADDP ST(1), ST			; add to ST(0) and pop
  FISTP xvalue		; store integer, pop stack
  printstr lf
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  xvalue			; load integer
  FSTP  x87buff			; store in print buffer
  invoke FloatToStr2, x87buff, addr FltString
  printstr FltString
  printstr lf
; --------------------------------------------------
  mov  esi, offset MyArray
  call freeArray
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
