;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1S		DB  'ten',0
	VARX2S		DB  'twenty',0
	VARX3S		DB  'thirty',0
	VARX4S		DB  'forty',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	_int_start	dd	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
	MyStrArry		DD	?
			DW	61	dup(?)
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  mov  esi, offset MyStrArry			; dimension an array
  mov  edi, esi
  add  edi, 4
  mov word ptr [edi], 1
  add  edi, 2
  mov word ptr [edi], 1
  call dimstrarray
; --------------------------------------------------
  mov  esi, offset MyStrArry			; re-dimension an array
  mov  edi, esi
  add  edi, 4
  mov word ptr [edi], 2
  add  edi, 2
  mov word ptr [edi], 2
  add  edi, 2
  mov word ptr [edi], 2
  call redimarray
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 1
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX1S			; load temp variable address
  call copystrng
  pop  edi
  push edi
  mov  eax, edi
  mov  edi, [eax]
  call copystrng_bffr		; alloc memory and copy
  pop  edi
  mov  [edi], eax			; store address-pointer
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 1
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 2
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX2S			; load temp variable address
  call copystrng
  pop  edi
  push edi
  mov  eax, edi
  mov  edi, [eax]
  call copystrng_bffr		; alloc memory and copy
  pop  edi
  mov  [edi], eax			; store address-pointer
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 2
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX3S			; load temp variable address
  call copystrng
  pop  edi
  push edi
  mov  eax, edi
  mov  edi, [eax]
  call copystrng_bffr		; alloc memory and copy
  pop  edi
  mov  [edi], eax			; store address-pointer
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 2
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 2
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  push edi
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX4S			; load temp variable address
  call copystrng
  pop  edi
  push edi
  mov  eax, edi
  mov  edi, [eax]
  call copystrng_bffr		; alloc memory and copy
  pop  edi
  mov  [edi], eax			; store address-pointer
  cls
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 1
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 1
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 2
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 2
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 1
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  mov  edi, offset MyStrArry
  push edi
  add  edi, 6
  mov  esi, offset array_mtrx
  push esi
  mov  [esi], word ptr 2
  add  esi, 2
  mov  [esi], word ptr 0
  add  esi, 2
  mov  [esi], word ptr 2
  pop  esi
  call getArryOffst
  pop  esi
  mov  edi, [esi]
  add  edi, eax
  mov  eax, [edi]
  .if eax != 0
    printvar eax
  .endif
  printstr lf
; --------------------------------------------------
  mov  esi, offset MyStrArry
  call freeArray
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
