;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
  .486                       ; use 486 instructions
  .model flat, syscall
  option casemap:none        ; case sensitive
; =========================================================================
; BXB Function Prototypes:
; =========================================================================
 
; =========================================================================
  include BXB.inc
; -------------------------------------------------------------------------
; =========================================================================
;  INITIALIZED DATA
; =========================================================================
 .data
	VARX1I		DD  0
	VARX2S		DB  NULL
	VARX3S		DB  'Press a number key,(from 1 to 5):',0
	VARX4S		DB  NULL
	VARX5S		DB  'The number you pressed was:',0
	VARX6S		DB  ' One',0
	VARX7S		DB  ' Two',0
	VARX8S		DB  ' Three',0
	VARX9S		DB  ' Four',0
	VARX10S		DB  ' Five',0
	VARX11S		DB  ' Oops!',0
; --------------------------------------------------
; Do Not Delete !!!:  Constants and system variables
; --------------------------------------------------
	integer    dd  0
	x87buff    dq  0
; --------------------------------------------------
; =========================================================================
;  UNINITIALIZED DATA
; =========================================================================
 .data?
	system_time 	 tm<?,?,?,?,?,?,?,?,?,?,?>			;current date & time
	iCOL		dd	?
	iROW		dd	?
	iYear		dd	?
	iMonth		dd	?
	iDay		dd	?
	iHour		dd	?
	iMinute		dd	?
	iSecond		dd	?
	iMilli		dd	?
	hStdHandle	dd	?
	IntString	db	12		dup(?)	; integer string
	FltString	db	28		dup(?)
	BffrInput	db	BUFSIZE		dup(?)
	iohandles	DD	99		dup(?)
	iobuffers	DD	99		dup(?)
	iLVAR		dd	?
	iRVAR		dd	?
	qLVAR		dq	?
	qRVAR		dq	?
	array_mtrx	DW	60		dup(?)
	_var_start	dd	?
	a		DD	?
	_int_start	dd	?
	IntVal		DD	?
	_flt_start	dd	?
	_var_endzz	dd	?
	StringBffr	db	MBUFSIZE	dup(?)
	_arry_start	dd	?
; =========================================================================
 .code
; =========================================================================
 _start:
; =========================================================================
  invoke Main
  invoke exit, 0
; =========================================================================
; --------------------------------------------------
Main proc
; --------------------------------------------------
  pushad
  call Do_initialize
; --------------------------------------------------
  FINIT 			; initialize x87
  FILD  VARX1I			; load integer
  FISTP IntVal		; store integer, pop stack
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  mov  esi, offset VARX2S			; load temp variable address
  call copystrng
  mov  edi, [a]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  a, eax			; store address-pointer
  cls
  printstr VARX3S
  printstr lf
  ;--------------------<while>
Unq_2_Label:
  mov  esi, [a]			; address of source string
  mov  edi, offset VARX4S		; load temp variable address
  invoke StrLen, addr VARX4S		; get string length
  .if eax == 0
    inc  eax
  .endif
  mov  ecx, eax				; Load length of string
  cld			; clear direction flag: work upward
  repe cmpsb		; Compare and repeat
  jne  Unq_1_Label
  ;--------------------<block>
; --------------------------------------------------
  lea  eax, StringBffr
  mov  [eax], byte ptr 0		; clear string-copy buffer
  call inkeystr
  call copystrng
  mov  edi, [a]			; load address-pointer
  call copystrng_bffr		; alloc memory and copy
  mov  a, eax			; store address-pointer
  ;--------------------<end-block>
  jmp  Unq_2_Label
  ;--------------------<wend>
Unq_1_Label:
; --------------------------------------------------
  FINIT 			; initialize x87
  mov  eax, [a]
  invoke StrToFloat, eax, addr qLVAR
  FLD  qLVAR
  FISTP IntVal		; store integer, pop stack
  printstr VARX5S
  ;--------------------<switch>
  mov eax, IntVal
  ;--------------------<case block>
  .if eax == 1
    printstr VARX6S
    printstr lf
    jmp Unq_3_Label
  ;--------------------<case block>
  .elseif eax == 2
    printstr VARX7S
    printstr lf
    jmp Unq_3_Label
  ;--------------------<case block>
  .elseif eax == 3
    printstr VARX8S
    printstr lf
    jmp Unq_3_Label
  ;--------------------<case block>
  .elseif eax == 4
    printstr VARX9S
    printstr lf
    jmp Unq_3_Label
  ;--------------------<case block>
  .elseif eax == 5
    printstr VARX10S
    printstr lf
    jmp Unq_3_Label
  ;--------------------<case block>
  .else 
    printstr VARX11S
    printstr lf
    jmp Unq_3_Label
  .endif 
  ;--------------------<end switch>
Unq_3_Label:
TheEnd:
  jmp  DONE
;
DONE:
  ; --------------------------------------------------
  ; --------------------------------------------------
Alldone:
  call _getch 			  ; pause
  popad
  ret                                       ; return to windows
  ; --------------------------------------------------
Main endp
; =========================================================================
; =========================================================================
end _start
; =========================================================================
; =========================================================================
